local trp3rio = CreateFrame("Frame")
trp3rio:RegisterEvent("ADDON_LOADED")
trp3rio:RegisterEvent("PLAYER_LOGIN")
trp3rio:RegisterEvent("PLAYER_LOGOUT")
trp3rio:RegisterEvent("PLAYER_ENTERING_WORLD")


local ignoretooltip = false
local loadedstuff = false

local normalRaidColor = "|cff1eff00"
local normalRaidColorText = "|cff98f989"
local heroicRaidColor = "|cff0070dd"
local heroicRaidColorText = "|cff67abea"
local mythicRaidColor = "|cffa335ee"
local mythicRaidColorText = "|cffce94f7"


local function fixFontsTrp3RIO (dummy)

--Incredibly rough but it works, for now
			local line = _G[strconcat(TRP3_CharacterTooltip:GetName(), "TextLeft", TRP3_CharacterTooltip:NumLines())]
			local font, _ , flag = line:GetFont()
			line:SetFont(font, 12, flag)
			
			local line2 = _G[strconcat(TRP3_CharacterTooltip:GetName(), "TextRight", TRP3_CharacterTooltip:NumLines())]
			local font2, _ , flag2 = line2:GetFont()
			line2:SetFont(font2, 12, flag2)
			
			--print('called')


end



trp3rio:SetScript("OnEvent", function(self, event, arg1, arg2)


    if event == "PLAYER_LOGIN" and loadedstuff == false then
		--loadedstuff = true

	 if TRP3_CharacterTooltip ~= nil then
			TRP3_CharacterTooltip:HookScript("OnShow", function(t)

				
				--print(TRP3_CharacterTooltip['target'])
				--print(RaiderIO.HasPlayerProfile(TRP3_CharacterTooltip['target']))
						
				
				if (RaiderIO.HasPlayerProfile(TRP3_CharacterTooltip['target']) == true) then
				
					loadedstuff = false
				
				
					--This player has a Raider.io Profile
					
					thisPlayerName = TRP3_CharacterTooltip['target']

		
					thisPlayerTables = RaiderIO.GetPlayerProfile(0, thisPlayerName)
				
					
				if (thisPlayerTables[1] or thisPlayerTables[2]) then

								
					TRP3_CharacterTooltip:AddDoubleLine(" ", " ", 100, 100, 0)
				
					
				
				end
				

				
				for i=1,3 do

						if (thisPlayerTables[i]) then
						
						
				
						
							if (thisPlayerTables[i]['profile']['dataType']) == 1 then
								--M+ data
								
								varPlayerScore = thisPlayerTables[i]['profile']['mplusCurrent']['score'];
								varPlayerScoreNum = varPlayerScore
								
								
								if (thisPlayerTables[i]['profile']['mplusPrevious']['score']) then
									if (varPlayerScore <= thisPlayerTables[i]['profile']['mplusPrevious']['score']) then
										varPlayerScore = "±" .. thisPlayerTables[i]['profile']['mplusPrevious']['score']
										varPlayerScoreNum = thisPlayerTables[i]['profile']['mplusPrevious']['score']
									end 
								end
						
								
								--print(RaiderIO.GetScoreColor(varPlayerScoreNum))
								
								
								TRP3_CharacterTooltip:AddDoubleLine("R.IO M+ Score", varPlayerScore, 1, 1, 0, RaiderIO.GetScoreColor(varPlayerScoreNum));
								
								
									fixFontsTrp3RIO()

								
								
								
							end
							
							if (thisPlayerTables[i]['profile']['dataType']) == 2 then
								--Raid Data
								
								
								varBossCount = thisPlayerTables[i]['profile']['currentRaid']['bossCount']
								varRaidName = thisPlayerTables[i]['profile']['currentRaid']['shortName']
								
								
								if (thisPlayerTables[i]['profile']['previousRaid']) then
									varBossCountPrevious = thisPlayerTables[i]['profile']['previousRaid']['bossCount']
									varRaidNamePrevious = thisPlayerTables[i]['profile']['previousRaid']['shortName']
								
								end
								
								
								
								
								
								strRaidProgress = ""
								strRaidProgressPrevious = ""
								
								for z=1,3  do
								
										-- current prog
										if (thisPlayerTables[i]['profile']['progress'][z]) then
										
										
											if (thisPlayerTables[i]['profile']['progress'][z]['difficulty']) == 1 then
												--Normal
												
												strRaidProgress = strRaidProgress .. normalRaidColor .. "    N " .. normalRaidColorText .. thisPlayerTables[i]['profile']['progress'][z]['progressCount'] .. "/" .. varBossCount
												
												
											end
											
											if (thisPlayerTables[i]['profile']['progress'][z]['difficulty']) == 2 then
												--Heroic
												 
												strRaidProgress = strRaidProgress .. heroicRaidColor .. "    H " .. heroicRaidColorText .. thisPlayerTables[i]['profile']['progress'][z]['progressCount'] .. "/" .. varBossCount
												
											end
											
											
											if (thisPlayerTables[i]['profile']['progress'][z]['difficulty']) == 3 then
												--Mythic												
												strRaidProgress = strRaidProgress .. mythicRaidColor .. "    M " .. mythicRaidColorText .. thisPlayerTables[i]['profile']['progress'][z]['progressCount'] .. "/" .. varBossCount
												
											end
											

										end
										
										
										
										
										
										-- previous prog
										if (thisPlayerTables[i]['profile']['previousProgress']) then
											if (thisPlayerTables[i]['profile']['previousProgress'][z]) then
											
											
												if (thisPlayerTables[i]['profile']['previousProgress'][z]['difficulty']) == 1 then
													--Normal
													
													strRaidProgressPrevious = strRaidProgressPrevious  .. normalRaidColor .. "    N " .. normalRaidColorText .. thisPlayerTables[i]['profile']['previousProgress'][z]['progressCount'] .. "/" .. varBossCountPrevious
													
													
												end
												
												if (thisPlayerTables[i]['profile']['previousProgress'][z]['difficulty']) == 2 then
													--Heroic
													 
													strRaidProgressPrevious = strRaidProgressPrevious .. heroicRaidColor .. "    H " .. heroicRaidColorText .. thisPlayerTables[i]['profile']['previousProgress'][z]['progressCount'] .. "/" .. varBossCountPrevious
													
												end
												
												
												if (thisPlayerTables[i]['profile']['previousProgress'][z]['difficulty']) == 3 then
													--Mythic												
													strRaidProgressPrevious = strRaidProgressPrevious .. mythicRaidColor .. "    M " .. mythicRaidColorText .. thisPlayerTables[i]['profile']['previousProgress'][z]['progressCount'] .. "/" .. varBossCountPrevious
													
												end
												

											end
										end
										
										
										
										
								
								end
								
								
			
			
								if (strRaidProgress ~= "") then
								
									TRP3_CharacterTooltip:AddDoubleLine("R.IO " .. varRaidName .. " Progress" , strRaidProgress, 100, 100, 0 );
								
									fixFontsTrp3RIO()
									
								
								end
											
								
								
							
								
								if (strRaidProgressPrevious ~= "") then
								
									TRP3_CharacterTooltip:AddDoubleLine("R.IO " .. varRaidNamePrevious .. " Progress" , strRaidProgressPrevious, 100, 100, 0 );
									
									fixFontsTrp3RIO()
									
								
								end
								
								
								
								
								
								
							end
						
						
						end 
						
					
					
					end
				
					
					
						
					--for k, v in pairs(thisPlayerTables[2]['profile']['progress'][1]) do
					-- print(k, v)
					--end
					
					--for k, v in pairs(thisPlayerTables[2]['profile']['progress'][2]) do
					-- print(k, v)
					--end
					
					
					--for k, v in pairs(RaiderIO.GetScoreColor(thisPlayerTables[1]['profile']['mplusCurrent']['score'])) do
					 --print(k, v)
					--end
					
					--print(thisPlayerTables[1]['profile']['dataType'])
					
					
					
					
				end
				
					
				 
				TRP3_CharacterTooltip:Show()
				TRP3_CharacterTooltip:GetTop()
				
	
				
			
			end)
		end
	 
	 
	 
		    
    end
	
	
	
end)

